#!/usr/bin/python3

from utils import *

# portable code to get filename
import os
platform = os.path.basename(__file__)
if platform.endswith(".py"):
	platform = platform[:(-3)]

def extract_from_url (url, verbosity):
	# split into domain and path
	slash1 = url.find("/",url.find("//")+2)
	domain = url[:slash1]
	path = url[slash1:]

	# get page type
	slash2 = path.find("/",1)
	if slash2 > 0:
		page_type = path[1:slash2]
	else:
		page_type = path[1:]

	if page_type == "channels":
		slash3 = path.find("/",slash2 + 1)
		if slash3 > 0:
			channel_name = path[slash2+1:slash3]
		else:
			channel_name = path[slash2+1:]

		# use home instance
		if '@' in channel_name:
			# TODO: how do we handle protocol (http vs. https)?
			# for now, assume it's the same as url, or https if not specified
			if "//" in domain:
				protocol = domain[:domain.index("//")+2]
			else:
				protocol = "https://"
			debug ("Assuming " + protocol + " for remote instance", verbosity, platform)
			at_index = channel_name.find("@")
			domain = protocol + channel_name[at_index+1:]
			channel_name = channel_name[:at_index]

		if channel_name != "":
			return domain + "/api/v1/channels/" + channel_name + "/rss"

def extract (url, page=None, network=False, verbosity=3, args={}):
	feed = extract_from_url (url, verbosity)
	if not feed is None:
		return feed
